Pagination

clock 3-minute read calender updated Feb. 25, 2026

It's a real page-turner

Pagination keeps data manageable by breaking it into chunks, so systems handle large data requests without slowing down.

Row pagination

There are common pagination parameters like startRowIndex and endRowIndex that help retrieve and organize large data sets into separate, scrollable pages. This is commonly used with information reporting and transaction inquiry APIs. These parameters are optional and are not required for the request.

  • The startRowIndex query string parameter sets the first row in the response. The default value is 1.
  • The endRowIndex query string parameter sets the final row of data of the response. The default value is 1000 records and is also the maximum number of records allowed in a single transaction.
  • If the startRowIndex or endRowIndex parameters are blank, all rows of data are returned up to the maximum limit of the endRowIndex value for transaction records.
  • In the response header of the API, an endpoint may return totalRows or retrievedRows. These parameters provide a summary of the total number of transactions that match the request criteria or were retrieved based on the request criteria.

Example

This is an example of a request with general pagination parameters applied in the query string for the Previous Day API:

POST /ddaReports/accounts/v1/transactions/list?startRowIndex=5&endRowIndex=20

In this example, the startRowIndex is 5 so the first row of data returned is the fifth row, skipping the first four rows of data. The endRowIndex is 20 meaning that only 20 records are returned per page, starting from the fifth row.

Offset pagination

The offset pagination parameters are limit and offset. These parameters tell the server how many records to search for at a time and what records to skip. This parameter does not rely on filter/sort controls and is not a recommended parameter for very large sets of data.

  • The limit query string parameter tells the server how many items to return during a search. It restricts the number of rows returned. There is no maximum value for this parameter.
  • The offset query string parameter specifies which set of rows to return. You can use this parameter to set the starting row for the returned data and control which rows are skipped. The default value is zero (0).

Be cautious when using these parameters. If the data set changes, the results can be affected and may return an incorrect response.

Example

The following example shows a request example with the offset pagination parameters applied in the query string for the RTP Send Payment API:

GET /rtp/v1/payment/rtp/participant?limit=15&offset=0

In this example, the offset is 0, so no items are skipped, and the limit is 15, meaning the request searches 15 items at a time.

Page size

You can control how many pages and records are returned with page request parameters like pageSize and pageNumber

  • The pageNumber query string parameter specifies which page to start with in the returned response set. Typically, this value is set to 1 initially until you become familiar with the record sets returned by common queries.
  • The pageSize query string parameter defines the total number of records returned per page. This value must 1 or greater and cannot exceed 1000.

Example

The following example shows a request with page size parameters applied in the query string for the ACH Inquiry API:

POST /accounts/transactions/v1/ach/list?pageNumber=1&pageSize=50

In this example, the pageNumber is 1 returning the first page of the result set, and the pageSize is 50, meaning that only 50 records are returned starting from page 1.